// Copyright (C) 1991-2011 Altera Corporation
// Your use of Altera Corporation's design tools, logic functions
// and other software and tools, and its AMPP partner logic
// functions, and any output files from any of the foregoing
// (including device programming or simulation files), and any
// associated documentation or information are expressly subject
// to the terms and conditions of the Altera Program License
// Subscription Agreement, Altera MegaCore Function License
// Agreement, or other applicable license agreement, including,
// without limitation, that your use is for the sole purpose of
// programming logic devices manufactured by Altera and sold by
// Altera or its authorized distributors.  Please refer to the
// applicable agreement for further details.

// *****************************************************************************
// This file contains a Verilog test bench template that is freely editable to
// suit user's needs .Comments are provided in each section to help the user
// fill out necessary details.
// *****************************************************************************
// Generated on "04/11/2012 11:29:28"

// Verilog Test Bench template for design : AD7328
//
// Simulation tool : ModelSim-Altera (Verilog)
//

`timescale 1 ns/ 100 ps
module AD7328_vlg_tst();
// constants
// test vector input registers
reg adc_clk_i;
reg adc_sdo;
reg [15:0] data_i;
reg fpga_clk_i;
reg reset_n_i;

reg [15:0] data;
reg [15:0] temp;
// wires
wire adc_cs_n_o;
wire adc_sclk_o;
wire adc_sdi;
wire [15:0]  data_o;
wire data_rd_ready_o;

// assign statements (if any)
AD7328 i1 (
// port map - connection between master ports and signals/registers
    .adc_clk_i(adc_clk_i),
    .adc_cs_n_o(adc_cs_n_o),
    .adc_sclk_o(adc_sclk_o),
    .adc_sdi(adc_sdi),
    .adc_sdo(adc_sdo),
    .data_i(data_i),
    .data_o(data_o),
    .data_rd_ready_o(data_rd_ready_o),
    .fpga_clk_i(fpga_clk_i),
    .reset_n_i(reset_n_i)
);
initial
begin
        adc_clk_i   = 0;
        adc_sdo     = 0;
        data_i      = 16'haaaa;
        fpga_clk_i  = 0;
        reset_n_i   = 1;
        data        = 16'h8001;
        temp        = 16'h8001;

$display("Running testbench");
end

always
begin
    #25 adc_clk_i = ~adc_clk_i;
end

always 
begin
    #5 fpga_clk_i = ~fpga_clk_i;
end

always @(negedge adc_cs_n_o)
begin
    data = temp;
    temp = temp + 1;
    adc_sdo = data[15];
    data    = {data[14:0],1'b0};
end

always @(negedge adc_sclk_o)
begin
    adc_sdo = data[15];
    data    = {data[14:0],1'b0};
end

endmodule

